<template>
    <main id="js-page-content" role="main" class="page-content">
        <ol class="breadcrumb page-breadcrumb">
            <li class="breadcrumb-item"> <router-link to="/index">Dashboard</router-link> </li>
            <li class="breadcrumb-item"> <router-link to="/roles">Roles</router-link></li>
            <li class="breadcrumb-item active"> Role Detail</li>

        </ol>
        <div class="subheader">
            <h1 class="subheader-title">
                <i class='subheader-icon fal fa-tags'></i> {{roleName}}<span class='fw-300'></span>
            </h1>
            <div class="subheader-block d-lg-flex align-items-center border-faded border-right-0 border-top-0 border-bottom-0 ml-3 pl-3">
                <div class="d-inline-flex flex-column justify-content-center mr-3">
                    <button class="btn btn-danger" @click="openModal">
                         Add User To Role
                    </button>
                </div>
                <span class="sparklines hidden-lg-down" sparkType="bar" sparkBarColor="#fe6bb0" sparkHeight="32px" sparkBarWidth="5px" values="1,4,3,6,5,3,9,6,5,9,7"></span>
            </div>
        </div>

        <div class="row">
            <div class="col-md-6">
                <div id="panel-1" class="panel">
                    <div class="panel-hdr">
                        <h2>
                            Users <span class="fw-300"><i></i></span>
                        </h2>
                        <div class="panel-toolbar">
                            <button class="btn btn-panel" data-action="panel-collapse" data-toggle="tooltip" data-offset="0,10" data-original-title="Collapse"></button>
                            <button class="btn btn-panel" data-action="panel-fullscreen" data-toggle="tooltip" data-offset="0,10" data-original-title="Fullscreen"></button>
                        </div>
                    </div>
                    <div class="panel-container show">
                        <div class="panel-content">
                            <!-- datatable start -->
                            <table id="dt-basic-example" class="table table-bordered table-hover table-striped">
                                <thead>
                                    <tr>
                                        <th>S.N.</th>
                                        <th>Name</th>
                                        <th>Email</th>
                                    </tr>
                                </thead>
                                <tbody>
                                    <tr v-if="userWithSameRole.length==0">
                                        <td class="text-center" colspan="3">No users yet</td>
                                    </tr>
                                    <tr v-else v-for="(user,index) in userWithSameRole" :key="index">
                                        <td>{{index+1}}</td>
                                        <td>{{user.firstName +" "+ user.lastName}}</td>
                                        <td>{{user.username}}</td>
                                    </tr>
                                </tbody>
                            </table>
                            <!-- datatable end -->
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <!-- add modal -->
        <div class="modal fade" id="addModal" tabindex="-1" role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
            <div class="modal-dialog modal-dialog-centered modal-lg" role="document">
                <div class="modal-content">
                <div class="modal-body">
                    <div class="form-group">
                        <label class="form-label" for="users">Users</label>
                        <v-select :options="options" @input="selectDoc">
                            <template slot="option" slot-scope="option">
                                {{ option.label }}
                            </template>
                        </v-select>
                        <div class="mt-3 ml-2" v-for="(value,index) in users" :key="index">
                            <div class="row">
                                <div class="col-md-9">
                                    {{ value.label }}
                                </div>
                                <div class="col-md-3">
                                    <button class="btn btn-xs btn-danger" @click="remove(value)">Remove</button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                    <button type="button" class="btn btn-primary" @click="addUser()">Add</button>
                </div>
                </div>
            </div>
        </div>
    </main>
</template>

<script>
import vSelect from "vue-select";
    export default {
        components: {
            vSelect
        },
        name: 'AddUserToRole',
        data() {
            return {
                users: [],
                roleName: '',
                options : [],
                allUsers: [],
                userWithSameRole:[],
                userId: [],
                data:{
                    users:[],
                    roleName: ''
                }
            }
        },
        methods: {
            selectDoc (doc) {
                this.users.push(doc);
                this.userId.push(doc.value);
                this.options = this.options.filter(option => option != doc)
            },
            
            remove (doc) {
                this.options.push(doc);
                this.users = this.users.filter(value => value != doc)
                this.userId = this.userId.filter(value => value != doc.value)
            },

            fetchUsers() {
                this.$store.dispatch('user/all_user')
                .then(() => {
                    this.allUsers = this.$store.getters['user/users']
                    this.allUsers.forEach(user => {
                        this.options.push({"label":user.firstName +" "+ user.lastName +" ( "+user.username+" )", "value":user._id})
                    });
                })
            },

            fetchUsersWithSameRole(){
                this.$store.dispatch('role/getUsers', this.roleName)
                .then(() => {
                    this.userWithSameRole = this.$store.getters['role/users']
                })
            },

            addUser() {
                this.data.users = this.userId,
                this.data.roleName = this.roleName
                this.$store.dispatch('role/addUserToRole', this.data)
                .then(() => {
                    this.$$('#addModal').modal('hide')
                    this.userWithSameRole = this.fetchUsersWithSameRole()
                })
            },

            openModal(){
                this.$$('#addModal').modal('show')
            }
        },
        created(){
            this.roleName = this.$route.params.name
            this.fetchUsers()
            this.fetchUsersWithSameRole()
        }   
    }
</script>

<style scoped>

</style>
